﻿using PP_Ven_MosS.ModelBase;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PP_Ven_MosS.Classes;
using System.Collections.ObjectModel;
using static System.Net.Mime.MediaTypeNames;

namespace PP_Ven_MosS.Pages
{
    /// <summary>
    /// Логика взаимодействия для ApplicationsListAdmin.xaml
    /// </summary>
    public partial class ApplicationsListAdmin
    {
        User user = new User();
        private string evtype;
        public string EventType
        {
            get { return evtype; }
            set { evtype = value; }
        }

        private string apptype;

        public string ApplicType
        {
            get { return apptype; }
            set { apptype = value; }
        }
        private void CBCount_Loaded(object sender, RoutedEventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            comboBox.ItemsSource = new List<string> { "1", "2", "3", "4", "5" };
            Event ev = Classes.Database.entities.Event.FirstOrDefault();
            if (ev.score != null)
            {
                comboBox.SelectedValue = Convert.ToInt32(ev.score);
                EmployeeID.scores = Convert.ToInt32(comboBox.SelectedValue);
            }

        }
        private void CBCount_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ComboBox cb = (ComboBox)sender;
            EventList.SelectedItem = cb.SelectedItem;
            if (cb.Uid != null)
            {
                //int evid = int.Parse(cb.Uid);
                Event ev = Classes.Database.entities.Event.FirstOrDefault(x => x.Id_event.ToString() == cb.Uid);
                if (cb.SelectedItem != null)
                {
                    if (ev != null)
                    {
                        ev.score = Convert.ToInt32(cb.SelectedValue);
                        Classes.Database.entities.SaveChanges();
                    }
                }

            }


        }
    }
    public partial class ApplicationsListAdmin : Page
    {
        PP_MininEntities DB = new PP_MininEntities();
        int id;
        public ApplicationsListAdmin()
        {

            InitializeComponent();

            ApplicationList.ItemsSource = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            CB_Filter_app.ItemsSource = new List<string> { "Фильтр по статусу", "Выполнен", "Не выполнен" };
            CB_Sort_app.ItemsSource = new List<string>() { "Фильтр по дате", "Не сегодня", "Сегодня" };
            CB_Sort_app.SelectedIndex = 0;
            CB_Filter_app.SelectedIndex = 0;

            EventList.ItemsSource = DB.Event.ToList();
            Event evnt = DB.Event.Where(x => x.Id_event == id).FirstOrDefault();
            CB_Filter_event.ItemsSource = new List<string>() { "Фильтр по статусу", "Проведено", "Не проведено" };
            CB_Sort_event.ItemsSource = new List<string>() { "Фильтр по дате", "Не сегодня", "Сегодня" };
            CB_Sort_event.SelectedIndex = 0;
            CB_Filter_event.SelectedIndex = 0;


            //надо доделать биндинг, чтобы текст комбобокса был равен значению из базы
        }
        public ApplicationsListAdmin(int id)
        {
            InitializeComponent();
            ApplicationList.ItemsSource = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            CB_Filter_app.ItemsSource = DB.Applications.ToList();
            CB_Sort_app.ItemsSource = DB.Applications.ToList();
            CB_Sort_app.SelectedIndex = 0;
            CB_Filter_app.SelectedIndex = 0;
            this.id = id;

            EventList.ItemsSource = DB.Event.ToList();
            Event evnt = DB.Event.Where(x => x.Id_event == id).FirstOrDefault();
            CB_Filter_event.ItemsSource = new List<string>();
            CB_Sort_event.ItemsSource = new List<string>();
            CB_Sort_event.SelectedIndex = 0;
            CB_Filter_event.SelectedIndex = 0;
            this.id = id;
        }
        private void TF_Checked(object sender, RoutedEventArgs e)
        {
            // Сбор данных
            CheckBox cb = (CheckBox)sender;
            int id = Convert.ToInt32(cb.Uid);
            Applications applications = Classes.Database.entities.Applications.Where(x => x.Id_application == id).FirstOrDefault();

            // Проверка заявки на статус "не выполнена"
            if (applications.Id_status_app == 2)
            {
                // Обновление количества выполненных заявок пользователем
                User user = Classes.Database.entities.User.Where(x => x.Id_user == applications.Id_employee).FirstOrDefault();
                applications.Id_status_app = 1; //Изменение статуса служэебнй записки
                user.Count_complete_app++; // Увеличение числа выполненных служебных записок
                Classes.Database.entities.SaveChanges();


                // Обновление конкретной записи в листе
                List<Applications> appList = ApplicationList.ItemsSource.Cast<Applications>().ToList();
                int index = appList.FindIndex(x => x.Id_application == id);
                if (index >= 0)
                {
                    appList[index] = applications;
                    ApplicationList.ItemsSource = new ObservableCollection<Applications>(appList);
                    ApplicationList.Items.Refresh();
                    cb.Visibility = Visibility.Collapsed;
                }
            }
        }
        private void TFE_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cbe = (CheckBox)sender;
            int id = Convert.ToInt32(cbe.Uid);
            Event events = Classes.Database.entities.Event.FirstOrDefault(x => x.Id_event == id);
            // Проверка мероприятия на статус "не проведено"
            if (events.Id_status_event == 2)
            {
                // Обновление записи
                events.Id_status_event = 1;
                Classes.Database.entities.SaveChanges();

                // Обновление количества проведенных мероприятий пользователем
                user.Count_complete_event++;
                Classes.Database.entities.SaveChanges();

                // Обновление конкретной записи в листе
                List<Event> eventList = EventList.ItemsSource.Cast<Event>().ToList();
                int index = eventList.FindIndex(x => x.Id_event == id);
                if (index >= 0)
                {
                    eventList[index] = events;
                    EventList.ItemsSource = new ObservableCollection<Event>(eventList);
                    EventList.Items.Refresh();
                }
            }
        }
        private void Filter()
        {
            List<Applications> applications = DB.Applications.Where(x => x.Id_employee == UserID.userid).ToList();
            if (CB_Sort_app.SelectedIndex != 0)
            {
                switch (CB_Sort_app.SelectedIndex)
                {
                    case 1:
                        applications = applications.Where(x => x.Date_app < DateTime.Today).OrderBy(x => x.Date_app).ToList();
                        break;
                    case 2:
                        applications = applications.Where(x => x.Date_app == DateTime.Today).OrderBy(x => x.Date_app).ToList();
                        break;
                }
            }
            if (CB_Filter_app.SelectedIndex != 0)
            {
                switch (CB_Filter_app.SelectedIndex)
                {
                    case 1:
                        applications = applications.Where(x => x.Id_status_app == 1).ToList();
                        break;
                    case 2:
                        applications = applications.Where(x => x.Id_status_app == 2).ToList();
                        break;
                }
            }
            if (!string.IsNullOrEmpty(TB_Search_app.Text))
            {
                applications = applications.Where(x => x.Description.ToUpper().Contains(TB_Search_app.Text.ToUpper())).ToList();
            }
            ApplicationList.ItemsSource = applications;
            //Мероприятия
            List<Event> events = DB.Event.ToList();
            if (CB_Sort_event.SelectedIndex != 0)
            {
                switch (CB_Sort_event.SelectedIndex)
                {
                    case 1:
                        events = events.Where(x => x.Date_event < DateTime.Today).OrderBy(x => x.Date_event).ToList();
                        break;
                    case 2:
                        events = events.Where(x => x.Date_event == DateTime.Today).OrderBy(x => x.Date_event).ToList();
                        break;
                }
            }
            if (CB_Filter_event.SelectedIndex != 0)
            {
                switch (CB_Filter_event.SelectedIndex)
                {
                    case 1:
                        events = events.Where(x => x.Id_status_event == 1).ToList();
                        break;
                    case 2:
                        events = events.Where(x => x.Id_status_event == 2).ToList();
                        break;
                }
            }
            if (!string.IsNullOrEmpty(TB_Search_event.Text))
            {
                events = events.Where(x => x.Title_event.ToUpper().Contains(TB_Search_event.Text.ToUpper())).ToList();
            }
            EventList.ItemsSource = events;
        }

        private void SortFilterChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void SearchChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }
        private void TB_Search_event_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void CB_Sort_event_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void CB_Filter_event_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }
        private void Exit_Click(object sender, RoutedEventArgs e)
        {
            FrameClass.MainFrame.Navigate(new Avtorization());
        }
        private void Profile_Click(object sender, RoutedEventArgs e)
        {

            FrameClass.MainFrame.Navigate(new Profile(user));
        }
    }
}